package cc.smtweb.system.bpm.web.sys.user.user;

import cc.smtweb.framework.core.annotation.SwCache;
import cc.smtweb.framework.core.cache.AbstractEntityCache;
import cc.smtweb.framework.core.cache.CacheManager;
import cc.smtweb.framework.core.util.PubUtil;

import java.util.HashSet;
import java.util.Set;

/**
 * Created by 1 at 2022-07-29 09:25:43
 * 实体【[用户机构关系](SYS_USER_PARTY)】的缓存类
 */
@SwCache(ident = "SYS_USER_PARTY", title = "用户机构关系")
public class UserPartyCache extends AbstractEntityCache<UserParty> {
    //缓存key：按用户缓存
    public final static String mk_u = "u";

    public static UserPartyCache getInstance() {
        return CacheManager.getIntance().getCache(UserPartyCache.class);
    }

    public UserPartyCache() {
        //缓存key：按用户缓存
        regList(mk_u, "sup_user_id");
    }

    //缓存key：按用户缓存
    public final Set<UserParty> getByU(String key) {
        return getListByKey(mk_u, key);
    }

    public final Set<Long> getIdByUser(Long key) {
        Set<Long> ids = new HashSet<>();
        Set<UserParty> set = getByU(String.valueOf(key));
        if (PubUtil.isEmpty(set)) return ids;
        set.forEach(bean -> {
            ids.add(bean.getEntityId());
        });
        return ids;
    }
}
